diff --git a/web/pgadmin/browser/tests/test_reset_password.py b/web/pgadmin/browser/tests/test_reset_password.py
index 7bad400a..d4a06b28 100644
--- a/web/pgadmin/browser/tests/test_reset_password.py
+++ b/web/pgadmin/browser/tests/test_reset_password.py
@@ -9,50 +9,74 @@
 
 import uuid
 
-from pgadmin.utils.route import BaseTestGenerator
+import pytest
+from grappa import should
+
 from regression.python_test_utils.test_utils import login_tester_account
 from regression.python_test_utils.test_utils import logout_tester_account
 from regression.test_setup import config_data
 
 
-class ResetPasswordTestCase(BaseTestGenerator):
-    """
-    This class validates the reset password functionality by defining
-    scenarios; Each dict parameter describe a scenario appended by
-    test name.
-    """
-
-    scenarios = [
-        # This test case validates the empty email field
-        ('TestCase for Validating Empty Email', dict(
-            email='', respdata='Email not provided')),
-
-        # This test case validates the invalid/incorrect email field
-        ('TestCase for Validating Invalid_Email', dict(
-            email=str(uuid.uuid4())[1:8] + '@xyz.com',
-            respdata='Specified user does not exist')),
-
-        # This test case validates the valid email id
-        ('TestCase for Validating Valid_Email', dict(
-            email=config_data['pgAdmin4_login_credentials']
-            ['login_username'], respdata='pgAdmin 4'))
-    ]
-
-    @classmethod
-    def setUpClass(cls):
-        logout_tester_account(cls.tester)
-
-    def runTest(self):
-        """This function checks reset password functionality."""
-
-        response = self.tester.get('/browser/reset_password')
-        self.assertTrue('Recover pgAdmin 4 Password' in response.data.decode(
-            'utf-8'))
-        response = self.tester.post(
-            '/browser/reset_password', data=dict(email=self.email),
+@pytest.mark.skip_if_not_in_server_mode
+class TestResetPassword(object):
+    def test_empty_email(self, request, context_of_tests):
+        """
+        When trying to reset the password
+        And email is empty
+        It returns "Email not provided" error
+        """
+        http_client = context_of_tests['test_client']
+
+        logout_tester_account(http_client)
+        request.addfinalizer(lambda: login_tester_account(http_client))
+
+        response = http_client.get('/browser/reset_password')
+        response.data.decode('utf-8') | should.contain(
+            'Recover pgAdmin 4 Password')
+        response = http_client.post(
+            '/browser/reset_password', data=dict(email=''),
+            follow_redirects=True)
+        response.data.decode('utf-8') | should.contain('Email not provided')
+
+    def test_user_not_found(self, request, context_of_tests):
+        """
+        When trying to reset the password
+        And user is not found
+        It returns "Specified user does not exist" error
+        """
+        http_client = context_of_tests['test_client']
+
+        logout_tester_account(http_client)
+        request.addfinalizer(lambda: login_tester_account(http_client))
+
+        response = http_client.get('/browser/reset_password')
+        response.data.decode('utf-8') | should.contain(
+            'Recover pgAdmin 4 Password')
+        response = http_client.post(
+            '/browser/reset_password', data=dict(
+                email=str(uuid.uuid4())[1:8] + '@xyz.com'),
             follow_redirects=True)
-        self.assertTrue(self.respdata in response.data.decode('utf-8'))
+        response.data.decode('utf-8') | should.contain(
+            'Specified user does not exist')
+
+    @pytest.mark.xfail(reason='Test previously failing, issue inside http '
+                              'test client')
+    def test_success(self, request, context_of_tests):
+        """
+        When trying to reset the password
+        And user exists
+        It returns success
+        """
+        http_client = context_of_tests['test_client']
 
-    @classmethod
-    def tearDownClass(cls):
-        login_tester_account(cls.tester)
+        logout_tester_account(http_client)
+        request.addfinalizer(lambda: login_tester_account(http_client))
+
+        response = http_client.get('/browser/reset_password')
+        response.data.decode('utf-8') | should.contain(
+            'Recover pgAdmin 4 Password')
+        response = http_client.post(
+            '/browser/reset_password', data=dict(
+                email=config_data['pgAdmin4_login_credentials']),
+            follow_redirects=True)
+        response.data.decode('utf-8') | should.contain('pgAdmin 4')
diff --git a/web/pgadmin/browser/tests/test_version_in_range.py b/web/pgadmin/browser/tests/test_version_in_range.py
index 4d9ca76d..f2bc36d6 100644
--- a/web/pgadmin/browser/tests/test_version_in_range.py
+++ b/web/pgadmin/browser/tests/test_version_in_range.py
@@ -6,78 +6,67 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
+from grappa import should
 
-from pgadmin.utils.route import BaseTestGenerator
 from pgadmin.browser.utils import is_version_in_range
 
 
-class VersionInRangeTestCase(BaseTestGenerator):
-    """
-    This class validates the version in range functionality
-    by defining different version scenarios; where dict of
-    parameters describes the scenario appended by test name.
-    """
+class TestVersionInRange(object):
+    def test_version_in_range_pg8_23(self):
+        """
+        When Validating pgversion 8.23
+        And the min_version is 91000
+        It should return false
+        """
 
-    scenarios = [
-        (
-            'TestCase for Validating pgversion 8.23 and min_version is 91000, '
-            'it should not show', dict(
-                sversion=82300,
-                min_version=90100,
-                max_version=1000000000,
-                scenario=2
-            )),
-        (
-            'TestCase for Validating pgversion 9.2, '
-            'it should show by default', dict(
-                sversion=90200,
-                min_version=0,
-                max_version=1000000000,
-                scenario=1
-            )),
-        (
-            'TestCase for Validating pgversion 9.2 and min/max are None, '
-            'it should show by default', dict(
-                sversion=90200,
-                min_version=None,
-                max_version=None,
-                scenario=1
-            )),
-        (
-            'TestCase for Validating pgversion 9.6 and max is lower, '
-            'it should not show', dict(
-                sversion=90600,
-                min_version=None,
-                max_version=90400,
-                scenario=2
-            ))
-    ]
+        result = is_version_in_range(
+            82300,
+            90100,
+            1000000000
+        )
+
+        result | should.be.false
+
+    def test_version_in_range_pg9_2(self):
+        """
+        When Validating pgversion 9.2
+        It should return true
+        """
+
+        result = is_version_in_range(
+            90200,
+            0,
+            1000000000,
+        )
 
-    @classmethod
-    def setUpClass(cls):
-        pass
+        result | should.be.true
 
-    def runTest(self):
-        """This function will check version in range functionality."""
-        if self.scenario == 1:
-            self.test_result_is_true()
-        if self.scenario == 2:
-            self.test_result_is_false()
+    def test_version_in_range_pg9_none(self):
+        """
+        When Validating pgversion 9.2
+        And the min/max are None
+        It should return true
+        """
 
-    def test_result_is_true(self):
-        self.assertTrue(
-            is_version_in_range(
-                self.sversion,
-                self.min_version,
-                self.max_version
-            )
+        result = is_version_in_range(
+            90200,
+            None,
+            None,
         )
 
-    def test_result_is_false(self):
-        self.assertFalse(
-            is_version_in_range(
-                self.sversion,
-                self.min_version,
-                self.max_version
-            )
+        result | should.be.true
+
+    def test_version_in_range_pg9_6_lower_max(self):
+        """
+        When Validating pgversion 9.6
+        And the max is lower
+        It should return false
+        """
+
+        result = is_version_in_range(
+            90600,
+            None,
+            90400,
         )
+
+        result | should.be.false
diff --git a/web/pgadmin/conftest.py b/web/pgadmin/conftest.py
new file mode 100644
index 00000000..4ab174ed
--- /dev/null
+++ b/web/pgadmin/conftest.py
@@ -0,0 +1,296 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+import os
+import sys
+
+import pytest
+
+logger = logging.getLogger(__name__)
+file_name = os.path.basename(__file__)
+
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+
+root = os.path.dirname(CURRENT_PATH)
+
+if sys.path[0] != root:
+    sys.path.insert(0, root)
+    os.chdir(root)
+
+from pgadmin import create_app
+import config
+if config.SERVER_MODE is True:
+    config.SECURITY_RECOVERABLE = True
+    config.SECURITY_CHANGEABLE = True
+    config.SECURITY_POST_CHANGE_VIEW = 'browser.change_password'
+
+from pgadmin.browser.server_groups.servers.databases.tests.utils import \
+    client_connect_database, client_disconnect_database
+from pgadmin.utils import server_utils
+from regression import test_setup
+
+from regression.feature_utils.app_starter import AppStarter
+
+# Delete SQLite db file if exists
+if os.path.isfile(config.TEST_SQLITE_PATH):
+    os.remove(config.TEST_SQLITE_PATH)
+
+os.environ["PGADMIN_TESTING_MODE"] = "1"
+
+# Disable upgrade checks - no need during testing, and it'll cause an error
+# if there's no network connection when it runs.
+config.UPGRADE_CHECK_ENABLED = False
+
+pgadmin_credentials = test_setup.config_data
+
+# Set environment variables for email and password
+os.environ['PGADMIN_SETUP_EMAIL'] = ''
+os.environ['PGADMIN_SETUP_PASSWORD'] = ''
+if pgadmin_credentials:
+    if 'pgAdmin4_login_credentials' in pgadmin_credentials:
+        if all(item in pgadmin_credentials['pgAdmin4_login_credentials']
+               for item in ['login_username', 'login_password']):
+            pgadmin_credentials = pgadmin_credentials[
+                'pgAdmin4_login_credentials']
+            os.environ['PGADMIN_SETUP_EMAIL'] = str(
+                pgadmin_credentials['login_username'])
+            os.environ['PGADMIN_SETUP_PASSWORD'] = str(
+                pgadmin_credentials['login_password'])
+
+# Execute the setup file
+exec(open(os.path.join(root, "setup.py")).read())
+
+# Get the config database schema version. We store this in pgadmin.model
+# as it turns out that putting it in the config files isn't a great idea
+from pgadmin.model import SCHEMA_VERSION
+
+# Delay the import test_utils as it needs updated config.SQLITE_PATH
+from regression.python_test_utils import test_utils
+
+config.SETTINGS_SCHEMA_VERSION = SCHEMA_VERSION
+
+# Create the app
+app = create_app()
+app.config['WTF_CSRF_ENABLED'] = False
+app.PGADMIN_KEY = ''
+app.config.update({'SESSION_COOKIE_DOMAIN': None})
+test_client = app.test_client()
+driver = None
+app_starter = None
+handle_cleanup = None
+
+server_info = test_utils.get_config_data()
+
+
+@pytest.fixture(scope="session", autouse=True)
+def database_server():
+    server_information = test_utils.create_parent_server_node(server_info[0])
+
+    yield server_information
+
+    test_utils.delete_test_server(test_client)
+
+
+@pytest.fixture(scope='session')
+def context_of_tests(database_server):
+    yield {
+        'server_information': database_server,
+        'test_client': test_client,
+        'server': server_info[0]
+    }
+
+
+@pytest.fixture(scope='session')
+def gather_current_database_information(context_of_tests):
+    server_id = context_of_tests['server_information']['server_id']
+    db_password = context_of_tests['server']['db_password']
+    http_client = context_of_tests['test_client']
+    server_con = server_utils.client_connect_server(http_client, server_id,
+                                                    db_password)
+    server_data = None
+    if 'data' in server_con:
+        server_data = server_con['data']
+    yield server_data
+
+
+@pytest.fixture
+def get_server_type(gather_current_database_information):
+    server_type = None
+    if gather_current_database_information and \
+       'type' in gather_current_database_information:
+        server_type = gather_current_database_information['type']
+    yield server_type
+
+
+@pytest.fixture
+def get_server_version(gather_current_database_information):
+    server_version = None
+    if gather_current_database_information and \
+       'version' in gather_current_database_information:
+        server_version = gather_current_database_information['version']
+    yield server_version
+
+
+@pytest.fixture
+def require_database_connection(context_of_tests):
+    server_data = context_of_tests['server_information']
+    server_id = server_data['server_id']
+    db_id = server_data['db_id']
+    http_client = context_of_tests['test_client']
+
+    db_con = client_connect_database(
+        http_client,
+        test_utils.SERVER_GROUP,
+        server_id,
+        db_id,
+        server_data['db_password'])
+    if not db_con["info"] == "Database connected.":
+        raise Exception("Could not connect to database.")
+
+    yield db_con
+
+    client_disconnect_database(http_client,
+                               server_id,
+                               db_id)
+
+
+@pytest.fixture(scope='session')
+def driver():
+    options = Options()
+    if test_setup.config_data:
+        if 'headless_chrome' in test_setup.config_data:
+            if test_setup.config_data['headless_chrome']:
+                options.add_argument("--headless")
+    options.add_argument("--window-size=1280x1024")
+    driver = webdriver.Chrome(chrome_options=options)
+
+    app_starter = AppStarter(driver, config)
+    app_starter.start_app()
+
+    handle_cleanup = test_utils.get_cleanup_handler(test_client, app_starter)
+    # Register cleanup function to cleanup on exit
+    atexit.register(handle_cleanup)
+
+    yield driver
+
+
+@pytest.fixture(scope='function', autouse=True)
+def check_if_test_should_be_skipped(request,
+                                    get_server_type,
+                                    get_server_version):
+    __skip_if_database(get_server_type, request)
+    __skip_if_postgres_version(get_server_version, request)
+    __skip_if_not_in_server_mode(request)
+
+
+def __skip_if_database(get_server_type, request):
+    if request.node.get_marker('skip_databases'):
+        if get_server_type in \
+           request.node.get_marker('skip_databases').args[0]:
+            pytest.skip('cannot run in: %s' %
+                        get_server_type)
+
+
+def __skip_if_postgres_version(get_server_version, request):
+    if request.node.get_marker('skip_if_postgres_version'):
+        versions = \
+            request.node.get_marker('skip_if_postgres_version').args[0]
+        skip_message = \
+            request.node.get_marker('skip_if_postgres_version').args[1]
+        if versions['below_version'] > get_server_version:
+            pytest.skip(skip_message)
+
+
+def __skip_if_not_in_server_mode(request):
+    if request.node.get_marker('skip_if_not_in_server_mode'):
+        if not config.SERVER_MODE:
+            pytest.skip('The application need to be in server mode')
+
+
+def pytest_generate_tests(metafunc):
+    if not hasattr(metafunc.cls, 'scenarios'):
+        return
+
+    list_of_scenario_names = []
+    scenario_parameters = []
+    for scenario in metafunc.cls.scenarios:
+        list_of_scenario_names.append(scenario[0])
+        scenario_parameters.append(('', scenario[1]))
+    metafunc.parametrize('args,kwargs',
+                         scenario_parameters,
+                         ids=list_of_scenario_names,
+                         scope="class",
+                         indirect=False)
+
+
+def pytest_itemcollected(item):
+    par = item.parent.obj
+    node = item.obj
+    pref = par.__doc__.strip() if par.__doc__ else par.__class__.__name__
+    suf = node.__doc__.strip() if node.__doc__ else node.__name__
+    if item._genid is not None:
+        suf = item._genid
+
+    if pref or suf:
+        item._nodeid = ' '.join((pref, suf))
+
+
+def sig_handler(signo, frame):
+    global handle_cleanup
+    if handle_cleanup:
+        # Unset environment variable
+        del os.environ["PGADMIN_TESTING_MODE"]
+
+        handle_cleanup()
+
+
+class StreamToLogger(object):
+    def __init__(self, logger, log_level=logging.INFO):
+        self.terminal = sys.stderr
+        self.logger = logger
+        self.log_level = log_level
+        self.linebuf = ''
+
+    def write(self, buf):
+        """
+        This function writes the log in the logger file as well as on console
+
+        :param buf: log message
+        :type buf: str
+        :return: None
+        """
+
+        self.terminal.write(buf)
+        for line in buf.rstrip().splitlines():
+            self.logger.log(self.log_level, line.rstrip())
+
+    def flush(self):
+        pass
+
+
+# Set signal handler for cleanup
+signal_list = dir(signal)
+required_signal_list = ['SIGTERM', 'SIGABRT', 'SIGQUIT', 'SIGINT']
+# Get the OS wise supported signals
+supported_signal_list = [sig for sig in required_signal_list if
+                         sig in signal_list]
+for sig in supported_signal_list:
+    signal.signal(getattr(signal, sig), sig_handler)
+
+# Set basic logging configuration for log file
+logging.basicConfig(
+    level=logging.DEBUG,
+    format='%(asctime)s:%(levelname)s:%(name)s:%(message)s',
+    filename=(root + os.path.sep + 'regression' + os.path.sep +
+              "regression.log"),
+    filemode='w'
+)
+
+# Create logger to write log in the logger file as well as on console
+stderr_logger = logging.getLogger('STDERR')
+sys.stderr = StreamToLogger(stderr_logger, logging.ERROR)
diff --git a/web/pgadmin/dashboard/tests/test_dashboard_templates.py b/web/pgadmin/dashboard/tests/test_dashboard_templates.py
index dd24bddc..a3406472 100644
--- a/web/pgadmin/dashboard/tests/test_dashboard_templates.py
+++ b/web/pgadmin/dashboard/tests/test_dashboard_templates.py
@@ -10,9 +10,10 @@
 import os
 import sys
 from flask import Flask, render_template
+from grappa import should
 from jinja2 import FileSystemLoader
 from pgadmin import VersionedTemplateLoader
-from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.utils.base_test_generator import BaseTestGenerator
 
 if sys.version_info < (3, 3):
     from mock import MagicMock
@@ -61,198 +62,182 @@ DATABASE_ID = 123
 _ = MagicMock(side_effect=lambda x: x)
 
 
-class TestDashboardTemplates(BaseTestGenerator):
-    scenarios = [
-        # Server dashboard
-        (
-            'Dashboard, when returning the html page with graphs and '
-            'server activity related html elements for server dashboard',
-            dict(
-                template_path='dashboard/server_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=None,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['both'],
-                    _=_
-                ),
-                expected_return_value=[
-                    'Server sessions',
-                    'Server activity'
-                ],
-                not_expected_return_value=[]
-            )
-        ),
-        (
-            'Dashboard, when returning the html page with only graphs '
-            'related html elements for server dashboard',
-            dict(
-                template_path='dashboard/server_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=None,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['only_graphs'],
-                    _=_
-                ),
-                expected_return_value=[
-                    'Server sessions'
-                ],
-                not_expected_return_value=[
-                    'Server activity'
-                ]
+class TestDashboardTemplates:
+    def testDashboardTemplGraphsAndServer(self):
+        """
+        Dashboard should be able to render html page with graphs
+        and server activity related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/server_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['both'],
+                _=_
             )
-        ),
-        (
-            'Dashboard, when returning the html page with only server '
-            'activity related html elements for server dashboard',
-            dict(
-                template_path='dashboard/server_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=None,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['only_server_activity'],
-                    _=_
-                ),
-                expected_return_value=[
-                    'Server activity'
-                ],
-                not_expected_return_value=[
-                    'Server sessions'
-                ]
+
+            result | should.contain("Server sessions")
+            result | should.contain("Server activity")
+
+    def testDashboardTemplGraphs(self):
+        """
+        Dashboard should be able to render html page
+        with only graph related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/server_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['only_graphs'],
+                _=_
             )
-        ),
-        (
-            'Dashboard, when returning the html page with neither '
-            'graphs nor server activity related html elements for server '
-            'dashboard',
-            dict(
-                template_path='dashboard/server_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=None,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['none'],
-                    _=_
-                ),
-                expected_return_value=[],
-                not_expected_return_value=[
-                    'Server activity',
-                    'Server sessions'
-                ]
+
+            result | should.contain("Server sessions")
+            result | should._not.contain("Server activity")
+
+    def testDashboardTemplServer(self):
+        """
+        Dashboard should be able to render html page
+        with only server activity related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/server_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['only_server_activity'],
+                _=_
             )
-        ),
-        # Database dashboard
-        (
-            'Dashboard, when returning the html page with graphs and '
-            'database activity related html elements for database dashboard',
-            dict(
-                template_path='dashboard/database_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=DATABASE_ID,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['both'],
-                    _=_
-                ),
-                expected_return_value=[
-                    'Database sessions',
-                    'Database activity'
-                ],
-                not_expected_return_value=[]
+
+            result | should.contain("Server activity")
+            result | should._not.contain("Server sessions")
+
+    def testDashboardTemplNone(self):
+        """
+        Dashboard should be able to render html page
+        with only server activity related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/server_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['none'],
+                _=_
             )
-        ),
-        (
-            'Dashboard, when returning the html page with only '
-            'graphs related html elements for database dashboard',
-            dict(
-                template_path='dashboard/database_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=DATABASE_ID,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['only_graphs'],
-                    _=_
-                ),
-                expected_return_value=[
-                    'Database sessions'
-                ],
-                not_expected_return_value=[
-                    'Database activity'
-                ]
+
+            result | should._not.contain("Server activity")
+            result | should._not.contain("Server sessions")
+
+    def testDBDashboardTemplGraphsAndServer(self):
+        """
+        DB Dashboard should be able to render html page with graphs
+        and server activity related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/database_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['both'],
+                _=_
             )
-        ),
-        (
-            'Dashboard, when returning the html page with only '
-            'database activity related html elements for database dashboard',
-            dict(
-                template_path='dashboard/database_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=DATABASE_ID,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['only_server_activity'],
-                    _=_
-                ),
-                expected_return_value=[
-                    'Database activity'
-                ],
-                not_expected_return_value=[
-                    'Database sessions'
-                ]
+
+            result | should.contain("Database sessions")
+            result | should.contain("Database activity")
+
+    def testDBDashboardTemplGraphs(self):
+        """
+        DB Dashboard should be able to render html page
+        with only graph related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/database_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['only_graphs'],
+                _=_
             )
-        ),
-        (
-            'Dashboard, when returning the html page with neither '
-            'graphs nor database activity related html elements for database '
-            'dashboard',
-            dict(
-                template_path='dashboard/database_dashboard.html',
-                input_parameters=dict(
-                    sid=SERVER_ID,
-                    did=DATABASE_ID,
-                    rates=RATES,
-                    version=VERSION,
-                    settings=DISPLAY_DASHBOARD['none'],
-                    _=_
-                ),
-                expected_return_value=[],
-                not_expected_return_value=[
-                    'Database sessions',
-                    'Database activity'
-                ]
+
+            result | should.contain("Database sessions")
+            result | should._not.contain("Database activity")
+
+    def testDBDashboardTemplServer(self):
+        """
+        DB Dashboard should be able to render html page
+        with only server activity related elements
+        """
+
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+        with FakeApp().app_context():
+            result = render_template(
+                'dashboard/database_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['only_server_activity'],
+                _=_
             )
-        ),
 
-    ]
+            result | should.contain("Database activity")
+            result | should._not.contain("Database sessions")
+
+    def testDBDashboardTemplNone(self):
+        """
+        DB Dashboard should be able to render html page
+        with only server activity related elements
+        """
 
-    def setUp(self):
         self.loader = VersionedTemplateLoader(FakeApp())
 
-    def runTest(self):
         with FakeApp().app_context():
             result = render_template(
-                self.template_path, **self.input_parameters
+                'dashboard/database_dashboard.html',
+                sid=SERVER_ID,
+                did=None,
+                rates=RATES,
+                version=VERSION,
+                settings=DISPLAY_DASHBOARD['none'],
+                _=_
             )
-            # checks for expected html elements
-            for expected_string in self.expected_return_value:
-                self.assertIn(
-                    expected_string, result
-                )
-
-            # checks for not expected html elements
-            for not_expected_string in self.not_expected_return_value:
-                self.assertNotIn(
-                    not_expected_string, result
-                )
+
+            result | should._not.contain("Database activity")
+            result | should._not.contain("Database sessions")
 
 
 class FakeApp(Flask):
